// Mary_HigawariCurListBox.h

#pragma once


// ^C}ʎq
#define TI_LST_DRAG		(1)


// Xg̊eACeɊ֘AtŗLf[^
typedef struct tagIKO_LISTBOX_DATA	//
{
	CIkoStr		isTitle;		// \p^Cg
	int			nCheck;			// `FbN{bNX̏
	HICON		hIcon;			// ACRnh
	SIZE		szIcon;			// ACRTCY
	LPVOID		pUserData;		// [U[f[^
} IKO_LISTBOX_DATA, *LPIKO_LISTBOX_DATA;


// I[i[EBhEvV[W
LRESULT CALLBACK HigawariCurListBoxOwnerProc(
	HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );

// Xg{bNX EBhEvV[W
LRESULT CALLBACK HigawariCurListBoxProc(
	HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );


class CHigawariCurListBox
{
public:
	friend LRESULT CALLBACK HigawariCurListBoxOwnerProc(
		HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );

	friend LRESULT CALLBACK HigawariCurListBoxProc(
		HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );

public:
	CHigawariCurListBox(void);
	virtual ~CHigawariCurListBox(void);

	// ֐̈ HWND ƂĎgpł܂B
	operator HWND () const;

	// TuNX
	BOOL SubclassWnd( UINT uCtlID, HWND hWndParent, HINSTANCE hInst = NULL );

	// SetWndHeight
	BOOL SetWndHeight( int nMinItem );

	// WM_MEASUREITEM
	void OnMeasureItem( UINT nCtlID, LPMEASUREITEMSTRUCT lpMeasureItemStruct );
	// WM_DRAWITEM Xg{bNX`
	void OnDrawItem( UINT nCtlID, LPDRAWITEMSTRUCT pdi );
	// WM_ERASEBKGND
	BOOL OnEraseBkgnd( HDC hDC );
	// WM_DESTROY
	void OnDestroy();

	// xJ[ݒ
	void SetLabelColor(
		COLORREF crMain, COLORREF crWaku, COLORREF crText, COLORREF crMainSel,
		COLORREF crGMain, COLORREF crGWaku, COLORREF crGText, COLORREF crGMainSel
		);
	// }J[ݒ
	void SetInsertLineColor( COLORREF crInsertLine );
	// `FbN{bNXgpݒ
	BOOL UseCheckBox( BOOL bUse, UINT uChkID = 0, UINT uNonChkID = 0, COLORREF clrMask = 0, HINSTANCE hInst = NULL );

	// SetRedraw
	void SetRedraw( BOOL bRedraw = TRUE );
	// GetRedraw
	BOOL IsRedraw();
	// SetFocus
	HWND SetFocus();
	// GetItemHeight
	int GetItemHeight( int nNo = 0 ) const;
	// SetItemHeight
	int SetItemHeight( int nHeight, int nNo = 0 );
	// GetCurSel
	int GetCurSel() const;
	// SetCurSel
	int SetCurSel( int nSel );
	// SetBkColor
	void SetBkColor( COLORREF crBk );
	// GetItemCount
	int GetItemCount() const;
	// GetTopIndex
	int GetTopIndex() const;
	// SetTopIndex
	BOOL SetTopIndex( int nTopIndex );

	// GetCheck
	int GetCheck( int nIndex );
	// SetCheck
	int SetCheck( int nIndex, int nCheck = 0 );
	// ToggleCheck
	int ToggleCheck( int nIndex );
	// SetCheckAll
	int SetCheckAll( int nCheck = 0 );
	// GetIcon
	HICON GetIcon( int nIndex );
	// SetIcon
	BOOL SetIcon( int nIndex, HICON hIcon, int nW = 0, int nH = 0 );
	// SetCursor
	BOOL SetCursor( int nIndex, HCURSOR hCursor, int nW = 0, int nH = 0 );

	// GetStr()
	BOOL GetStr( CIkoStr* pisGetStr, int nIndex, LPVOID* pData = NULL );
	BOOL GetStr( int nIndex, CIkoStr* pisGetStr, LPVOID* pData = NULL );
	// InsStr()
	int InsStr( LPCTSTR psStr, int nIndex = -1, LPVOID pData = NULL );
	// GetItemData()
	LPVOID GetItemData( int nIndex );
	// SetItemData()
	BOOL SetItemData( int nIndex, LPVOID pData );
	// DelStr()
	BOOL DelStr( int nIndex );
	BOOL DelStr( int nIndex, LPVOID* pData );

	// RenameItem()
	BOOL RenameItem( LPCTSTR psNewStr, int nIndex );

	// ItemUp wACe
	void ItemUp( int nIndex = -1 );
	// ItemDown wACe
	void ItemDown( int nIndex = -1 );

	// GetCountPerPage
	int GetCountPerPage( int nIndex = 0 ) const;
	// HitTest
	int HitTest( LPPOINT pptCurPos = NULL ) const;

	// Sort()
	BOOL Sort( int nMode = 0 );

	// RedrawWindow
	BOOL RedrawWindow( CONST RECT *prcUpdate = NULL, HRGN hrgnUpdate = NULL, UINT uFlags = 0 );

	// ACe`tOZbg
	void SetDrawItem( BOOL bDrawItem );
	BOOL IsDrawItem();
	// witOZbg
	void SetEraseBk( BOOL bEB );
	BOOL IsEraseBk();


	// ACehbO
	BOOL IsItemDrag() const;

	// hbO
	void SetDragMode( BOOL bDragMode );
	// hbOmF
	BOOL IsDragMode() const;


//private:
protected:
	// WM_CTLCOLORLISTBOX
	LRESULT OnCtlColorListbox( WPARAM wParam, LPARAM lParam );
	// eR}h
	BOOL OnCommand( WPARAM wParam, LPARAM lParam );
	BOOL OnCommandFocus( WPARAM wParam, LPARAM lParam );
	// WM_SYSCOMMAND
	void OnSysCommand( WPARAM wParam, LPARAM lParam );
	// XgTopIndexXV
	void OnListTIUpdate();
	// WM_KEYDOWN
	BOOL OnKeyDown( WPARAM wParam, LPARAM lParam );
	// WM_SYSKEYDOWN
	BOOL OnSysKeyDown( WPARAM wParam, LPARAM lParam );
	// WM_LBUTTONDBLCLK
	void OnLButtonDblClk( WPARAM wParam, LPARAM lParam );
	// WM_LBUTTONDOWN
	void OnLButtonDown( WPARAM wParam, LPARAM lParam );
	// WM_LBUTTONUP
	void OnLButtonUp( WPARAM wParam, LPARAM lParam );
	// WM_RBUTTONDOWN
	void OnRButtonDown( WPARAM wParam, LPARAM lParam );
	// WM_MOUSEMOVE
	void OnMouseMove( WPARAM wParam, LPARAM lParam );
	// WM_SETFOCUS
	void OnSetFocus( WPARAM wParam );
	// WM_KILLFOCUS
	void OnKillFocus( WPARAM wParam );

	// WM_TIMER
	BOOL OnTimer( WPARAM wParam, LPARAM lParam );
	// hbO^C}X^[g
	void OnDragTimerStart();
	// hbO^C}Xgbv
	void OnDragTimerStop( BOOL bDragEnd = FALSE );


	// ACehbOJnO
	void DragItemSet( int nSel, POINT* pPos );
	// ACehbOJn
	void DragStart();
	// ACehbOI
	void DragEnd( int nTo );
	// ACehbOLZ
	void DragCancel();
	// hbȎ}
	void SetDragInsertLine( int nIndex );
	int GetDragInsertLine();

	// SelItemUp IꂽACe
	void SelItemUp();
	// SelItemDown IꂽACe
	void SelItemDown();
	// ACeړ
	BOOL MoveItem( int nItem, int nTo );

	// ŗLf[^쐬ď
	LPVOID NewIkoListBoxData();
	// GetItemDataLBD()
	LPVOID GetItemDataLBD( int nIndex );
	// SetItemDataLBD()
	BOOL SetItemDataLBD( int nIndex, LPVOID pData );


//private:
protected:
	HWND	m_hWnd;
	HWND	m_hWndParent;
	HINSTANCE	m_hInst;	// gp
	UINT	m_uCtlID;


	// xJ[
	COLORREF m_crMain;
	COLORREF m_crWaku;
	COLORREF m_crText;
	COLORREF m_crMainSel;
	COLORREF m_crGMain;
	COLORREF m_crGWaku;
	COLORREF m_crGText;
	COLORREF m_crGMainSel;
	// }J[
	COLORREF m_crInsertLine;

	COLORREF m_crBk;	// wiF
	HBRUSH	m_hbrBk;	// wiFuV


	BOOL	m_bUseCheckBox;		// `FbN{bNXgptO
	SIZE	m_szChkBox;			// `FbN{bNX̃TCY
	HIMAGELIST	m_hILChkBox;	// `FbN{bNX

	int		m_nMarginW;			// ̃}[W

	// IWĩEBhE vV[W
	WNDPROC m_pOrgProc;
	WNDPROC m_pOwnerProc;

	int		m_nSelItem;		// h~̂߂̑IԂ`悷ACe
	int		m_nFocusItem;	// h~̂߂̃tH[JXg`悷ACe

	BOOL	m_bDragMode;	// ACehbO

	int		m_nDragStart;	// i 0
							// }EX{^ꂽ 1
							// ̂܂܃hbOJnꂽ 2
	POINT	m_ptDragStartPos;	// hbOJn悤ƂĂ_
	RECT	m_rcDragStartRect;	// hbOJnȂ͈
	BOOL	m_bDragCancel;	// hbOLZtO
	int		m_nDragItem;	// hbÕACeԍ
	int		m_nInsertLine;	// hbȎ}`悷ACe
	int		m_nInsertLine2;	// O܂ő}ĂACe

	BOOL	m_bSetTimer;	// ^C}N TRUE

	BOOL	m_bSetRedraw;	// Xg{bNX`tO
	BOOL	m_bDrawItem;	// ACe`tO
	BOOL	m_bEB;			// witO
};

